/* 
*
*  ProLinga-Validate
*
*  Copyright (C) 2002-2008 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Validate.
*
*  ProLinga-Validate is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Validate is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Validate.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*
*/

#ifndef __SYNTAX_ERROR_HPP
#define __SYNTAX_ERROR_HPP


char errorSyntaxSeverity[3][10] = {"Ok", "Warning", "Error"};

struct errorSyntax
{       int errorNo;
	int severity;
	char description[80];
} errorSyntaxTable40000[] = {	
			{ 40000, 0, "No Error" },
			{ 40001, 2, "No language validation document" },
			{ 40002, 2, "Invalid logic command" },
			{ 40003, 2, "Invalid number of arguments" },
			{ 40004, 2, "Invalid argument" },
			{ 40005, 2, "Valid argument, invalid as closing argument" },
			{ 40006, 2, "Structure control command defined outside structure" },
			{ 40007, 2, "Structure close command defined outside structure" },
			{ 40008, 2, "Missing structure close command" },
			{ 40009, 2, "Invalid Data Dictionary Name" },
			{ 40010, 2, "Invalid Record Name" },
			{ 40011, 2, "Invalid Index Name" },
			{ 40012, 2, "Invalid Data Source Name" },
			{ 40013, 2, "Invalid Logic Name" }
};


#endif  /* __SYNTAX_ERROR_HPP */

