
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 33 "ValParser.ypp"

#include "ValCommon.h"
#include "ValConfig.hpp"
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
/*#include "SyntaxError.h" */
#include "SyntaxCheck.hpp"
#include "CmdValCmd.hpp"
#include "ValidateDocument.hpp"
#include "LogicCommands.hpp"
#include "ValMain.hpp"
#include "VCDocumentParse.hpp"

extern "C" 
{
	int yyparse(void);
	int yylex(void);
	int yywrap(void);
}

extern xmlDocPtr docSyntax;
extern FILE *yyin;
FILE *fp;

xmlDocPtr docVal;
xmlNodePtr curVal, curTmp, curLast;
xmlBufferPtr bufVal;
int lastCommand = 0;

ValIfElseStackPtr valIfElsePtr = NULL;
ValEndifStackPtr valEndifPtr = NULL;
ValForStackPtr valForPtr = NULL;
ValEndforStackPtr valEndforPtr = NULL;
ValBreakStackPtr valBreakPtr = NULL;
LoopListPtr loopListPtr = NULL;

int i = 1;
int j = 1;
int sequenceNo = 0, loopCounter = 0, lineNo = 1;
char *arg[255];

int yyerror(const char *);

LoopList::LoopList()
{
	stepNo = 0;
	stepValue = 0;
}

LoopList::~LoopList()
{
	/* nothing */
}


int LoopList::getLoopStep(LoopList **loopPtr, int step)
{
	LoopListPtr curPtr;

	/* Check if step exists in memlist */
	curPtr = *loopPtr;

	while (curPtr != NULL)
	{
		if (curPtr->stepNo == step)
			return curPtr->stepValue;
			
		curPtr = curPtr->nextPtr;
	}

	/* Return */
	return -1;
}

void LoopList::putLoopStep(LoopList **loopPtr, int step, int value)
{

	LoopListPtr curPtr, prevPtr, newPtr;

	/* Check if step exists in memlist */
	curPtr = *loopPtr;
	prevPtr = NULL;

	while (curPtr != NULL)
	{
		if (curPtr->stepNo == step)
		{
			curPtr->stepValue = value;
			return;
		}
		
		prevPtr = curPtr;
		curPtr = curPtr->nextPtr;
	}

	/* If not then append new record */
	newPtr = new LoopList;
	newPtr->stepNo = step;
	newPtr->stepValue = value;
	newPtr->nextPtr = NULL;

	if (prevPtr == NULL)
	{
		/* First Record */
		*loopPtr = newPtr;
	}
	else
	{
		prevPtr->nextPtr = newPtr;
	}
}

void LoopList::printList(LoopList *loopPtr) const
{
	LoopListPtr curPtr;

	curPtr = loopPtr;
	while (curPtr != NULL)
	{
		printf("Step : %d - Value : %d\n", curPtr->stepNo, curPtr->stepValue);
		curPtr = curPtr->nextPtr;
	}
}

void LoopList::deleteList(LoopList **loopPtr)
{
	LoopListPtr curPtr, nextPtr;

	curPtr = *loopPtr;
	*loopPtr = NULL;
	while (curPtr != NULL)
	{
		nextPtr = curPtr->nextPtr;
		delete curPtr;
		curPtr = nextPtr;
	}
}



ValIfElseStack::ValIfElseStack()
{
	stepNo = 0;
	nextPtr = NULL;
}

ValIfElseStack::~ValIfElseStack()
{
	/* Dummy ? */	
}

void ValIfElseStack::push(ValIfElseStack **topPtr, int step)
{
	ValIfElseStack *newPtr;


	newPtr = new ValIfElseStack;
	newPtr->stepNo = step;
	newPtr->nextPtr = *topPtr;
	*topPtr = newPtr;
}

int ValIfElseStack::pop(ValIfElseStack **topPtr)
{
	ValIfElseStack *tmpPtr;
	int returnValue;

	tmpPtr = *topPtr;
	returnValue = tmpPtr->stepNo;
	*topPtr = (*topPtr)->nextPtr;
	delete tmpPtr;
	return returnValue;
}

ValEndifStack::ValEndifStack()
{
	stepNo = 0;
	nextPtr = NULL;
}

ValEndifStack::~ValEndifStack()
{
	/* Dummy ? */	
}

void ValEndifStack::push(ValEndifStack **topPtr, int step)
{
	ValEndifStack *newPtr;


	newPtr = new ValEndifStack;
	newPtr->stepNo = step;
	newPtr->nextPtr = *topPtr;
	*topPtr = newPtr;
}

int ValEndifStack::pop(ValEndifStack **topPtr)
{
	ValEndifStack *tmpPtr;
	int returnValue;

	tmpPtr = *topPtr;
	returnValue = tmpPtr->stepNo;
	*topPtr = (*topPtr)->nextPtr;
	delete tmpPtr;
	return returnValue;
}

int ValEndifStack::getStep(ValEndifStack *topPtr)
{
	return topPtr->stepNo;
}

ValForStack::ValForStack()
{
	stepNo = 0;
	nextPtr = NULL;
}

ValForStack::~ValForStack()
{
	/* Dummy ? */	
}

void ValForStack::push(ValForStack **topPtr, int step)
{
	ValForStack *newPtr;

	newPtr = new ValForStack;
	newPtr->stepNo = step;
	newPtr->nextPtr = *topPtr;
	*topPtr = newPtr;
}

int ValForStack::pop(ValForStack **topPtr)
{
	ValForStack *tmpPtr;
	int returnValue;

	tmpPtr = *topPtr;
	returnValue = tmpPtr->stepNo;
	*topPtr = (*topPtr)->nextPtr;
	delete tmpPtr;
	return returnValue;
}

int ValForStack::getValue(ValForStack **topPtr)
{
	return (*topPtr)->stepNo;
}

ValEndforStack::ValEndforStack()
{
	stepNo = 0;
	nextPtr = NULL;
}

ValEndforStack::~ValEndforStack()
{
	/* Dummy ? */	
}

void ValEndforStack::push(ValEndforStack **topPtr, int step)
{
	ValEndforStack *newPtr;


	newPtr = new ValEndforStack;
	newPtr->stepNo = step;
	newPtr->nextPtr = *topPtr;
	*topPtr = newPtr;
}

int ValEndforStack::pop(ValEndforStack **topPtr)
{
	ValEndforStack *tmpPtr;
	int returnValue;

	tmpPtr = *topPtr;
	returnValue = tmpPtr->stepNo;
	*topPtr = (*topPtr)->nextPtr;
	delete tmpPtr;
	return returnValue;
}

int ValEndforStack::getValue(ValEndforStack **topPtr)
{
	return (*topPtr)->stepNo;
}

ValBreakStack::ValBreakStack()
{
	stepNo = 0;
	nextPtr = NULL;
}

ValBreakStack::~ValBreakStack()
{
	/* Dummy ? */	
}

void ValBreakStack::push(ValBreakStack **topPtr, int step)
{
	ValBreakStack *newPtr;


	newPtr = new ValBreakStack;
	newPtr->stepNo = step;
	newPtr->nextPtr = *topPtr;
	*topPtr = newPtr;
}

int ValBreakStack::pop(ValBreakStack **topPtr)
{
	ValBreakStack *tmpPtr;
	int returnValue;

	tmpPtr = *topPtr;
	returnValue = tmpPtr->stepNo;
	*topPtr = (*topPtr)->nextPtr;
	delete tmpPtr;
	return returnValue;
}

int ValBreakStack::getValue(ValBreakStack **topPtr)
{
	return (*topPtr)->stepNo;
}

void TransformStart(void)
{
	/* Init val document */
	lineNo = 1;
	sequenceNo = 0;
	docVal = xmlNewDoc((const xmlChar *)"1.0");
	docVal->children = xmlNewDocNode(docVal, NULL, (const xmlChar *)"ProLinga", NULL);
	curVal = xmlDocGetRootElement(docVal);
	curVal = xmlNewTextChild (curVal, NULL, (const xmlChar *)"Runner", (const xmlChar *)"");
	xmlNewProp (curVal, (const xmlChar *)"Version", (const xmlChar *)"1.0");
	curVal = xmlNewTextChild (curVal, NULL, (const xmlChar *)"Statements", (const xmlChar *)"");
	curTmp = curVal;


}

void AddCommand(const int lcmd)
{
	char str2int[5], strNextTrue[5], strNextFalse[5], strPrevNextTrue[5], strPrevNextFalse[5];
	int nextStep, loopValue;

	sequenceNo++;
	nextStep = sequenceNo + 1;
	curVal = curTmp;
	curVal = xmlNewTextChild (curVal, NULL, (const xmlChar *)"Statement", (const xmlChar *)"");
	sprintf(str2int,"%d",sequenceNo);
        xmlNewProp (curVal, (const xmlChar *)"SequenceNo", (const xmlChar *)str2int);
	sprintf(strNextTrue,"%d",nextStep);
	sprintf(strNextFalse,"%d",nextStep);
	if (lcmd == LCMD_RETURN)
	{
		sprintf(strNextTrue,"0");
		sprintf(strNextFalse,"0");
	}
	else if (lcmd == LCMD_IF)
	{
		/* Create Endif Stack entry */
		loopCounter --;
		loopListPtr->putLoopStep(&loopListPtr, loopCounter, -1);
		valEndifPtr->push(&valEndifPtr, loopCounter);

		/* NextFalse unknown at this stage */
		loopCounter--;
		nextStep = loopCounter;
		sprintf(strNextFalse,"%d",nextStep);

		/* Create list entry */
		loopListPtr->putLoopStep(&loopListPtr, loopCounter, -1);

		/* Create stack entry */
		valIfElsePtr->push(&valIfElsePtr, loopCounter);
	}
	else if (lcmd == LCMD_ELSEIF)
	{
		if (valIfElsePtr != 0)
		{
			loopValue = valIfElsePtr->pop(&valIfElsePtr);
			nextStep = sequenceNo;
			loopListPtr->putLoopStep(&loopListPtr, loopValue, nextStep);

			/* NextFalse unknown at this stage */
			loopCounter--;
			sprintf(strNextFalse,"%d",loopCounter);
		
			loopListPtr->putLoopStep(&loopListPtr, loopCounter, -1);

			valIfElsePtr->push(&valIfElsePtr, loopCounter);

			/* Set next step last statement to ENDIF */
			loopValue = valEndifPtr->getStep(valEndifPtr);
		}
		else
			loopValue = 0;

		sprintf(strPrevNextTrue,"%d",loopValue);
		sprintf(strPrevNextFalse,"%d",loopValue);
        	xmlSetProp (curLast, (const xmlChar *)"NextTrue", (const xmlChar *)strPrevNextTrue);
        	xmlSetProp (curLast, (const xmlChar *)"NextFalse", (const xmlChar *)strPrevNextFalse);
	}
	else if (lcmd == LCMD_ELSE)
	{
		if (valIfElsePtr != NULL)
		{
			loopValue = valIfElsePtr->pop(&valIfElsePtr);
			nextStep = sequenceNo;
			loopListPtr->putLoopStep(&loopListPtr, loopValue, nextStep);

			loopCounter--;
			//sprintf(strNextTrue,"%d",loopCounter);
			//sprintf(strNextFalse,"%d",loopCounter);
	
			/* Dummy entries, but for consitency with elseif */	
			loopListPtr->putLoopStep(&loopListPtr, loopCounter, -1);
			valIfElsePtr->push(&valIfElsePtr, loopCounter);

			/* Set next step last statement to ENDIF */
			loopValue = valEndifPtr->getStep(valEndifPtr);
		}
		else
			loopValue = 0;

		sprintf(strPrevNextTrue,"%d",loopValue);
		sprintf(strPrevNextFalse,"%d",loopValue);
        	xmlSetProp (curLast, (const xmlChar *)"NextTrue", (const xmlChar *)strPrevNextTrue);
        	xmlSetProp (curLast, (const xmlChar *)"NextFalse", (const xmlChar *)strPrevNextFalse);
	}
	else if (lcmd == LCMD_ENDIF)
	{
		if (valIfElsePtr != NULL)
		{
			loopValue = valIfElsePtr->pop(&valIfElsePtr);
			loopListPtr->putLoopStep(&loopListPtr, loopValue, sequenceNo);

			/* Set ENDIF step */
			loopValue = valEndifPtr->pop(&valEndifPtr);
			loopListPtr->putLoopStep(&loopListPtr, loopValue, sequenceNo);
		}

	}
	else if ((lcmd == LCMD_FOR) || (lcmd == LCMD_FOREACH))
	{
		/* Create For stack entry */
		loopValue = sequenceNo + 1;
		valForPtr->push(&valForPtr, loopValue);

		/* Add begin mark to break stack */
		valBreakPtr->push(&valBreakPtr, 0);

		/* Create Endfor Stack entry */
		loopCounter --;
		loopListPtr->putLoopStep(&loopListPtr, loopCounter, -1);
		valEndforPtr->push(&valEndforPtr, loopCounter);

		/* Next False unknown so far */
		nextStep = loopCounter;
		sprintf(strNextFalse,"%d",nextStep);
	}
	else if (lcmd == LCMD_FOREVER)
	{
		/* Create For stack entry */
		loopValue = sequenceNo + 1;
		valForPtr->push(&valForPtr, loopValue);

		/* Add begin mark to break stack */
		valBreakPtr->push(&valBreakPtr, 0);

		/* Create Endfor Stack entry */
		loopCounter --;
		loopListPtr->putLoopStep(&loopListPtr, loopCounter, -1);
		valEndforPtr->push(&valEndforPtr, loopCounter);

		/* Next False unknown so far */
		nextStep = loopCounter;
		sprintf(strNextFalse,"%d",nextStep);
	}
	else if (lcmd == LCMD_BREAK)
	{
		if (valForPtr != NULL)
		{
			/* NextTrue + NextFalse unknown at this stage */
			loopCounter--;
			nextStep = loopCounter;

			/* Create break stack entry */
			valBreakPtr->push(&valBreakPtr, loopCounter);

			/* Create list entry */
			loopListPtr->putLoopStep(&loopListPtr, loopCounter, -1);

		}
		else
			nextStep = 0;

		sprintf(strNextTrue,"%d",nextStep);
		sprintf(strNextFalse,"%d",nextStep);
	}
	else if (lcmd == LCMD_CONTINUE)
	{
		if (valForPtr != NULL)
			loopValue = valForPtr->getValue(&valForPtr);
		else
			loopValue = 0;

		sprintf(strNextTrue,"%d",loopValue);
		sprintf(strNextFalse,"%d",loopValue);
	}
	else if (lcmd == LCMD_ENDFOR)
	{
		if (valForPtr != NULL)
		{
			loopValue = valForPtr->pop(&valForPtr);

			sprintf(strNextTrue,"%d",loopValue);
			sprintf(strNextFalse,"%d",loopValue);
	
			nextStep = sequenceNo + 1;

			/* Get all break statements */
			for (;;)
			{
				loopValue = valBreakPtr->pop(&valBreakPtr);
				if ( loopValue == 0)
					break;

				loopListPtr->putLoopStep(&loopListPtr, loopValue, nextStep);
			}
			loopValue = valEndforPtr->pop(&valEndforPtr);
			loopListPtr->putLoopStep(&loopListPtr, loopValue, nextStep);
		}
		else
		{
			loopValue = 0;
			sprintf(strNextTrue,"%d",loopValue);
			sprintf(strNextFalse,"%d",loopValue);

		}
	}

        xmlNewProp (curVal, (const xmlChar *)"NextTrue", (const xmlChar *)strNextTrue);
        xmlNewProp (curVal, (const xmlChar *)"NextFalse", (const xmlChar *)strNextFalse);
	sprintf(str2int,"%d",lcmd);
        xmlNewProp (curVal, (const xmlChar *)"Command", (const xmlChar *)str2int);
	sprintf(str2int,"%d",lineNo);
        xmlNewProp (curVal, (const xmlChar *)"LogicLineNo", (const xmlChar *)str2int);
	curLast = curVal;
	curVal = xmlNewTextChild (curVal, NULL, (const xmlChar *)"Arguments", (const xmlChar *)"");
	lastCommand = lcmd;
}

void AddArgument(const char *arg)
{
	xmlNewTextChild (curVal, NULL, (const xmlChar *)"Argument", (const xmlChar *)arg);

}

void TransformStop(void)
{

	xmlNodePtr cur;
	xmlXPathContextPtr ctxt;
	xmlXPathObjectPtr res;
	int i, stepNo, stepValue, stepNextTrue, stepNextFalse;
	char tmpValue[5];
	
	if (lastCommand != LCMD_ENDFOR)
	{
        	xmlSetProp (curLast, (const xmlChar *)"NextTrue", (const xmlChar *)"0");
        	xmlSetProp (curLast, (const xmlChar *)"NextFalse", (const xmlChar *)"0");
	}

	/* Post Process document */

	/* Init XPath */
	xmlXPathInit();

	/* Create XPath environment */
	ctxt = xmlXPathNewContext(docVal);

	res = xmlXPathEval((const xmlChar *)"/ProLinga/Runner/Statements/Statement[attribute::NextTrue<\"0\" or attribute::NextFalse<\"0\"]", ctxt);

	/* Check If Results */
	if (res->nodesetval->nodeTab == NULL)
		return;

	/* Process Results */
	cur = res->nodesetval->nodeTab[0];

	for (i=1; i<=res->nodesetval->nodeNr; i++)
	{
		stepNextTrue = atoi((char *)xmlGetProp(cur, (const xmlChar *)"NextTrue"));
		stepNextFalse = atoi((char *)xmlGetProp(cur, (const xmlChar *)"NextFalse"));

		if (stepNextTrue < 0)
			stepNo = stepNextTrue;
		else
			stepNo = stepNextFalse;

		stepValue = loopListPtr->getLoopStep(&loopListPtr, stepNo);

		if (stepValue > sequenceNo)
			stepValue = 0;

		sprintf(tmpValue,"%d",stepValue);

		if (stepNextTrue < 0)
			xmlSetProp(cur, (const xmlChar *)"NextTrue", (const xmlChar *)tmpValue);
		if (stepNextFalse < 0)
			xmlSetProp(cur, (const xmlChar *)"NextFalse", (const xmlChar *)tmpValue);


		/* Get next */
		cur = res->nodesetval->nodeTab[i];
	}	

	//loopListPtr->printList(loopListPtr);

	loopListPtr->deleteList(&loopListPtr);
/*
	bufVal = xmlBufferCreate();
        curVal = xmlDocGetRootElement(docVal);
        xmlNodeDump(bufVal, docVal, curVal, 0, 1);
        printf("%s\n", (char *)xmlBufferContent(bufVal));
*/
}

xmlDocPtr qqqCreateErrorDoc(void)
{
	xmlDocPtr docError;
	xmlNodePtr curError;

	/* Create empty error document */
	docError = xmlNewDoc((const xmlChar *)"1.0");
	docError->children = xmlNewDocNode(docError, NULL, (const xmlChar *)"ProLinga", NULL);
	curError = xmlDocGetRootElement(docError);
	curError = xmlNewTextChild (curError, NULL, (const xmlChar *)"Runner", (const xmlChar *)"");
	xmlNewProp (curError, (const xmlChar *)"Version", (const xmlChar *)"1.0");
	curError = xmlNewTextChild (curError, NULL, (const xmlChar *)"ValidateErrors", (const xmlChar *)"");

	/* Return */
	return docError;
}

void qqInsertError(const int lineno, const int argno, const int id, const char *severity, const char *description, const char *details, xmlDocPtr docError)
{
	xmlNodePtr curError;
	char dummy[10]="";

	/* Set Pointer */
	curError = xmlDocGetRootElement(docError);
	curError = curError->xmlChildrenNode;
	curError = xmlGetLastChild(curError);

	/* Insert Error */
	curError = xmlNewTextChild (curError, NULL, (const xmlChar *)"ValidateError", (const xmlChar *)"");
	sprintf(dummy, "%d", lineno);
	xmlNewProp (curError, (const xmlChar *)"LineNo", (const xmlChar *)dummy);
	sprintf(dummy, "%d", argno);
	xmlNewProp (curError, (const xmlChar *)"ArgumentNo", (const xmlChar *)dummy);
	xmlNewTextChild (curError, NULL, (const xmlChar *)"Severity", (const xmlChar *)severity);
	sprintf(dummy, "%d", id);
	xmlNewTextChild (curError, NULL, (const xmlChar *)"Id", (const xmlChar *)dummy);
	xmlNewTextChild (curError, NULL, (const xmlChar *)"Description", (const xmlChar *)description);
	xmlNewTextChild (curError, NULL, (const xmlChar *)"Details", (const xmlChar *)details);
}

/*
void qqInsertPredefinedError(const int lineno, const int argno, const int id, const char *details, xmlDocPtr docError)
{
	InsertError(lineno, argno, id, errorSyntaxSeverity[errorSyntaxTable40000[(id-40000)].severity], errorSyntaxTable40000[(id-40000)].description, details, docError);
}

*/


void SyntaxCheck(const char *applicationName)
{
	xmlDocPtr docError;
	xmlXPathContextPtr ctxVal, ctxSyntax;
	xmlXPathObjectPtr resVal, resSyntax;
	int i,stmCount=0, logicLineNo=0, lcmd;
	int argCount=0, minArguments=0, maxArguments=0;
	int pathNo, stepNo, syntaxStepNo, nextStepNo;
	char evalString[255], *stringValid, *argument, style[255], *staticValue = NULL;
	bool valOK = true, argOK, lastStep=false, nextStm=false;
	ValIfElseStackPtr cmdIfPtr = NULL;
	ValForStackPtr cmdForPtr = NULL;

	/* Create Empty Error Doc */
	docError = ValCreateErrorDoc();	

	/* Check if Syntax File Loaded */
	//docSyntax = ParseSyntaxDoc();
	if (docSyntax == NULL)
	{
		/* Set Status */
		valOK = false;

		/* Insert Error */
		ValInsertPredefinedError(0, 0, 40001, "", docError);

		/* Copy Error info to output tree */
		xmlFreeDoc(docVal);
		docVal = xmlCopyDoc(docError,1);

		/* Clean up and return */
		//xmlFreeDoc(docSyntax);
		xmlFreeDoc(docError);
		return;
	}

	/* Init XPath */
	xmlXPathInit();

	/* Create XPath environments */
	ctxVal = xmlXPathNewContext(docVal);
	ctxSyntax = xmlXPathNewContext(docSyntax);

	/* Get number of statements */
	resVal = xmlXPathEval((const xmlChar *)"count(/ProLinga/Runner/Statements/Statement)", ctxVal);
	stmCount = (int)xmlXPathCastToNumber(resVal);

	/* Loop through all statements */
	for (i=1; i<=stmCount;i++)
        {
		/* Loop init */
		maxArguments = 0;
		minArguments = 0;
		nextStm = false;

		/* Get Logic Line No */
		sprintf(evalString, "/ProLinga/Runner/Statements/Statement[%d]/@LogicLineNo",i);
		resVal = xmlXPathEval((const xmlChar *)evalString, ctxVal);
		logicLineNo = (int)xmlXPathCastToNumber(resVal);

		/* Get Logic Command */
		sprintf(evalString, "/ProLinga/Runner/Statements/Statement[%d]/@Command",i);
		resVal = xmlXPathEval((const xmlChar *)evalString, ctxVal);
		lcmd = (int)xmlXPathCastToNumber(resVal);

		/* Test if command in syntax file */
		sprintf(evalString, "/ProLinga/Language/LogicCommands/LogicCommand[@Command='%d']", lcmd);
		resSyntax = xmlXPathEval((const xmlChar *)evalString, ctxSyntax);

		/* Check for valid logic command */
		if(xmlXPathNodeSetIsEmpty(resSyntax->nodesetval))
		{
			/* Set Status */
			valOK = false;

			/* Get first argument containing invalid lcmd */
			sprintf(evalString, "/ProLinga/Runner/Statements/Statement[%d]/Arguments/Argument[1]",i);
			resVal = xmlXPathEval((const xmlChar *)evalString, ctxVal);
			stringValid = (char *)xmlXPathCastToString(resVal);

			/* Insert Error */
			ValInsertPredefinedError(logicLineNo, 0, 40002, stringValid, docError);

			/* Continue */
			continue;
		}

		/* Prevent structure control commands to be used outside any structure */
		if (((lcmd == LCMD_BREAK) || (lcmd == LCMD_CONTINUE)) && (cmdForPtr == NULL))
		{
			/* Set Status */
			valOK = false;

			/* Insert Error */
			ValInsertPredefinedError(logicLineNo, 0, 40006, "", docError);

			/* Continue */
			continue;
		}
		
		/* Prevent structure control commands to be used outside any structure */
		if (((lcmd == LCMD_ELSE) || (lcmd == LCMD_ELSEIF)) && (cmdIfPtr == NULL))
		{
			/* Set Status */
			valOK = false;

			/* Insert Error */
			ValInsertPredefinedError(logicLineNo, 0, 40006, "", docError);

			/* Continue */
			continue;
		}

		/* Prevent structure close commands to be used outside any structure */
		if (((lcmd == LCMD_ENDIF) && (cmdIfPtr == NULL)) || ((lcmd == LCMD_ENDFOR) && (cmdForPtr == NULL)))
		{
			/* Set Status */
			valOK = false;

			/* Insert Error */
			ValInsertPredefinedError(logicLineNo, 0, 40007, "", docError);

			/* Continue */
			continue;
		}

		/* Keep track of nested IF/FOR/FOREVER structures */
		if (lcmd == LCMD_IF)
			cmdIfPtr->push(&cmdIfPtr, logicLineNo);

		else if (lcmd == LCMD_ENDIF)
			cmdIfPtr->pop(&cmdIfPtr);

		else if ((lcmd == LCMD_FOR) || (lcmd == LCMD_FOREACH) || (lcmd == LCMD_FOREVER))
			cmdForPtr->push(&cmdForPtr, logicLineNo);

		else if (lcmd == LCMD_ENDFOR)
			cmdForPtr->pop(&cmdForPtr);

		/* Check for valid number of arguments */
		sprintf(evalString, "/ProLinga/Language/LogicCommands/LogicCommand[@Command='%d']/MinArguments", lcmd);
		resSyntax = xmlXPathEval((const xmlChar *)evalString, ctxSyntax);
		if(!xmlXPathNodeSetIsEmpty(resSyntax->nodesetval))
			minArguments = (int)xmlXPathCastToNumber(resSyntax);

		sprintf(evalString, "/ProLinga/Language/LogicCommands/LogicCommand[@Command='%d']/MaxArguments", lcmd);
		resSyntax = xmlXPathEval((const xmlChar *)evalString, ctxSyntax);
		if(!xmlXPathNodeSetIsEmpty(resSyntax->nodesetval))
			maxArguments = (int)xmlXPathCastToNumber(resSyntax);

		/* Get number of arguments */
		sprintf(evalString, "count(/ProLinga/Runner/Statements/Statement[%d]/Arguments/Argument)",i);
		resVal = xmlXPathEval((const xmlChar *)evalString, ctxVal);
		argCount = (int)xmlXPathCastToNumber(resVal);

		if ((argCount < minArguments) | (argCount > maxArguments))
		{
			/* Set Status */
			valOK = false;

			/* Insert Error */
			ValInsertPredefinedError(logicLineNo, 0, 40003, "", docError);

			/* Continue */
			continue;
		}

		/* If no arguments no point to process further */
		if (argCount == 0) 
			continue;

		/* Process Arguments */
		nextStepNo = 0;
		for (stepNo=1; stepNo<=argCount;stepNo++)
		{
			/* Init */
			pathNo = 1;
			if (nextStepNo != 0)
				syntaxStepNo = nextStepNo;
			else
				syntaxStepNo = stepNo;

			/* Get Argument */
			sprintf(evalString,"/ProLinga/Runner/Statements/Statement[%d]/Arguments/Argument[%d]",i,stepNo);
			resVal = xmlXPathEval((const xmlChar *)evalString, ctxVal);
			argument = (char *)xmlXPathCastToString(resVal);

			/* Get Style */
			for (;;)
			{
				/* Init */
				staticValue = NULL;

				sprintf(evalString, "/ProLinga/Language/LogicCommands/LogicCommand[@Command='%d']/Arguments/Argument[@Step='%d']/ArgumentStep[@Path='%d']/@NextStep", lcmd, syntaxStepNo, pathNo);
				resSyntax = xmlXPathEval((const xmlChar *)evalString, ctxSyntax);
				if (xmlXPathNodeSetIsEmpty(resSyntax->nodesetval))
					nextStepNo = 0;
				else
					nextStepNo = (int)xmlXPathCastToNumber(resSyntax);

				sprintf(evalString, "/ProLinga/Language/LogicCommands/LogicCommand[@Command='%d']/Arguments/Argument[@Step='%d']/ArgumentStep[@Path='%d']/@LastStep", lcmd, syntaxStepNo, pathNo);
				resSyntax = xmlXPathEval((const xmlChar *)evalString, ctxSyntax);
				lastStep = false;
				if ((!xmlXPathNodeSetIsEmpty(resSyntax->nodesetval)) && (strcmp((char *)xmlXPathCastToString(resSyntax), "True") == 0))
					lastStep = true;
	


				sprintf(evalString, "/ProLinga/Language/LogicCommands/LogicCommand[@Command='%d']/Arguments/Argument[@Step='%d']/ArgumentStep[@Path='%d']/@Style", lcmd, syntaxStepNo, pathNo);
				resSyntax = xmlXPathEval((const xmlChar *)evalString, ctxSyntax);
				if (xmlXPathNodeSetIsEmpty(resSyntax->nodesetval))
				{
					/* Set Status */
					valOK = false;

					/* Insert Error */
					ValInsertPredefinedError(logicLineNo, stepNo, 40004, argument, docError);

					/* Next Statement */
					nextStm = true;
					break;

				}

				/* Get Style */
				strcpy(style,(char *)xmlXPathCastToString(resSyntax));

				if (strcmp(style, "Static") == 0)
				{
					sprintf(evalString, "/ProLinga/Language/LogicCommands/LogicCommand[@Command='%d']/Arguments/Argument[@Step='%d']/ArgumentStep[@Path='%d']/@Value", lcmd, syntaxStepNo, pathNo);
					resSyntax = xmlXPathEval((const xmlChar *)evalString, ctxSyntax);
					if (xmlXPathNodeSetIsEmpty(resSyntax->nodesetval))
						staticValue = NULL;
					else
						staticValue = (char *)xmlXPathCastToString(resSyntax);


				}


				/* Check argument against style */
				argOK = CheckArgumentStyle(applicationName, argument, style, staticValue);

				if (argOK == false)
				{
					pathNo = pathNo + 1;
					continue;
				}

				/* Next Statement */
				break;
			}

			if (nextStm == true)
				break;

		}

		if (nextStm == true)
			continue;

		/* If ends with unexpected argument, error */
		if ((lastStep == false) && (valOK == true))
		{
			valOK = false;

			/* Insert Error */
			ValInsertPredefinedError(logicLineNo, stepNo, 40005, argument, docError);
		}

	}

	/* Check if all structures are close */
	if (cmdIfPtr != NULL)
	{
		/* Set Status */
		valOK = false;	

		/* Insert Error */
		ValInsertPredefinedError(cmdIfPtr->pop(&cmdIfPtr), 0, 40008, "ENDIF", docError);
	}
	if (cmdForPtr != NULL)
	{
		/* Set Status */
		valOK = false;	

		/* Insert Error */
		ValInsertPredefinedError(cmdForPtr->pop(&cmdForPtr), 0, 40008, "ENDFOR", docError);
		
	}

	if (valOK == false)
	{
		/* Copy Error info to output tree */
		xmlFreeDoc(docVal);
		docVal = xmlCopyDoc(docError,1);
	}

	/* Clean up  + Return*/
//	xmlFreeDoc(docSyntax);
	xmlFreeDoc(docError);
}




/* Line 189 of yacc.c  */
#line 1064 "ValParser.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     LCMD = 258,
     ILCMD = 259,
     CMT = 260,
     AOID = 261,
     BOS = 262,
     EOS = 263
   };
#endif
/* Tokens.  */
#define LCMD 258
#define ILCMD 259
#define CMT 260
#define AOID 261
#define BOS 262
#define EOS 263




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 1024 "ValParser.ypp"

	char *sval;
	int numval;
	


/* Line 214 of yacc.c  */
#line 1123 "ValParser.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1135 "ValParser.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   23

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  9
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  17
/* YYNRULES -- Number of rules.  */
#define YYNRULES  27
/* YYNRULES -- Number of states.  */
#define YYNSTATES  35

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   263

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     6,     8,    10,    12,    14,    16,    18,
      22,    25,    27,    31,    34,    37,    41,    43,    45,    47,
      49,    52,    54,    56,    59,    61,    63,    66
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      10,     0,    -1,    11,    10,    -1,    11,    -1,    15,    -1,
      12,    -1,    13,    -1,    14,    -1,    16,    -1,    18,    24,
       8,    -1,    18,     8,    -1,     8,    -1,    17,    20,     8,
      -1,    17,     8,    -1,    19,     8,    -1,    19,    22,     8,
      -1,     5,    -1,     3,    -1,     4,    -1,    21,    -1,    20,
      21,    -1,     6,    -1,    23,    -1,    22,    23,    -1,     6,
      -1,    25,    -1,    24,    25,    -1,     6,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1040,  1040,  1040,  1044,  1044,  1044,  1044,  1044,  1048,
    1052,  1056,  1060,  1060,  1064,  1064,  1068,  1072,  1076,  1080,
    1080,  1084,  1088,  1088,  1092,  1096,  1096,  1100
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "LCMD", "ILCMD", "CMT", "AOID", "BOS",
  "EOS", "$accept", "file", "statement", "argumentstatement",
  "commandstatement", "emptystatement", "commentstatement",
  "faultstatement", "cmt", "lcmd", "nlcmd", "comment", "partcomment",
  "faultarguments", "faultargument", "argument", "aoid", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,     9,    10,    10,    11,    11,    11,    11,    11,    12,
      13,    14,    15,    15,    16,    16,    17,    18,    19,    20,
      20,    21,    22,    22,    23,    24,    24,    25
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     1,     1,     1,     1,     1,     3,
       2,     1,     3,     2,     2,     3,     1,     1,     1,     1,
       2,     1,     1,     2,     1,     1,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    17,    18,    16,    11,     0,     3,     5,     6,     7,
       4,     8,     0,     0,     0,     1,     2,    21,    13,     0,
      19,    27,    10,     0,    25,    24,    14,     0,    22,    12,
      20,     9,    26,    15,    23
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    19,    20,    27,    28,    23,    24
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -9
static const yytype_int8 yypact[] =
{
      -3,    -9,    -9,    -9,    -9,     3,    -3,    -9,    -9,    -9,
      -9,    -9,    -2,     1,     2,    -9,    -9,    -9,    -9,     5,
      -9,    -9,    -9,     6,    -9,    -9,    -9,     9,    -9,    -9,
      -9,    -9,    -9,    -9,    -9
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
      -9,    10,    -9,    -9,    -9,    -9,    -9,    -9,    -9,    -9,
      -9,    -9,    -1,    -9,    -8,    -9,     0
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
       1,     2,     3,    15,    17,     4,    18,    21,    25,    22,
      26,    17,    21,    29,    31,    25,    16,    33,    30,    34,
       0,     0,     0,    32
};

static const yytype_int8 yycheck[] =
{
       3,     4,     5,     0,     6,     8,     8,     6,     6,     8,
       8,     6,     6,     8,     8,     6,     6,     8,    19,    27,
      -1,    -1,    -1,    23
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     8,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,     0,    10,     6,     8,    20,
      21,     6,     8,    24,    25,     6,     8,    22,    23,     8,
      21,     8,    25,     8,    23
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:

/* Line 1455 of yacc.c  */
#line 1048 "ValParser.ypp"
    { for (j=1;j<i;j++) AddArgument(arg[j]); i=1; lineNo++; }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 1052 "ValParser.ypp"
    { lineNo++; }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 1056 "ValParser.ypp"
    { lineNo++; }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 1060 "ValParser.ypp"
    { lineNo++; }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 1060 "ValParser.ypp"
    { lineNo++; }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 1064 "ValParser.ypp"
    { lineNo++; }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 1064 "ValParser.ypp"
    { lineNo++; }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 1068 "ValParser.ypp"
    { }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 1072 "ValParser.ypp"
    { AddCommand((yyvsp[(1) - (1)].numval)); }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 1076 "ValParser.ypp"
    { AddCommand(LCMD_UNKNOWN); AddArgument((yyvsp[(1) - (1)].sval)); }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 1084 "ValParser.ypp"
    { }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 1092 "ValParser.ypp"
    { }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 1100 "ValParser.ypp"
    { arg[i] = (yyvsp[(1) - (1)].sval); i++; }
    break;



/* Line 1455 of yacc.c  */
#line 2436 "ValParser.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1104 "ValParser.ypp"

//int main()
xmlDocPtr ValidateDoc(const bool transformOnly, const char *applicationName, const char *fname)
{
	/* Init + Write header info */
	TransformStart();

	/* Parse/Validate */
	yyin = fopen(fname, "r");
	yyparse();
	fclose(yyin);

	/* Write footer info + Close */
	TransformStop();

	/* Check if SyntaxCheck is required */
	if (transformOnly == false)
		SyntaxCheck(applicationName);

	/* End */	
	return docVal;
}

int yyerror(const char *msg)
{
	//printf("%d: %s at '%s'\n", yylineno, msg, yytext);
	printf("Error encountered: %s\n", msg);

	/* Recovery not attempted */
	return 1;
}


